@tool
class_name ImagePicker
extends Panel

signal file_selected(path)
signal texture_selected(texture)
signal canceled()

var _fs_tab_index := 1

@onready var fs_list := $VBoxContainer/TabContainer/Filesystem/FileList

func _ready():
	# TODO: fix Android
	if OS.get_name() == "Android":
		$VBoxContainer/TabContainer.set_tab_disabled(_fs_tab_index, true)
	else:
		fs_list.populate(OS.get_system_dir(OS.SYSTEM_DIR_PICTURES))

func _on_FileList_file_selected(path):
	emit_signal("file_selected", path)

func _on_FileList_texture_selected(texture):
	emit_signal("texture_selected", texture)

func _on_Cancel_pressed():
	emit_signal("canceled")
